﻿using System.Diagnostics;
using Combinatorics.Collections;
using System.Collections.Generic;
using static System.Console;

namespace predprs
{
    class Program
    {
        static void Main(string[] args)
        {
            double[,] matrix = new double[,]            //матрица прибылей
            {
                { 0, 0, 0, 0, 0 },
                { 0.5, 0.1, 0.6, 0.3, 1.0 },
                { 1.0, 0.5, 1.1, 0.6, 1.2 },
                { 1.4, 1.2, 1.2, 1.3, 1.3 },
                { 2, 1.8, 1.4, 1.4, 1.3 },
                { 2.5, 2.5, 1.6, 1.5, 1.3 },
                { 2.8, 2.9, 1.7, 1.5, 1.3 },
                { 3, 3.5, 1.8, 1.5, 1.3 },
                { 3, 3.5, 1.8, 1.5, 1.3 },
                { 3, 3.5, 1.8, 1.5, 1.3 },
                { 3, 3.5, 1.8, 1.5, 1.3 }
            };

            for(int i = 0; i < matrix.GetLength(0); i++)//её вывод
            {
                for (int j = 0; j < matrix.GetLength(1); j++) Write("{0:0.0} ", matrix[i, j]);
                WriteLine();
            }
            WriteLine("\n\n");

            int[] data = { 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 7, 8, 9, 10 };
            Variations<int> variations = new Variations<int>(data, 5);//всевозможные чиcла в комбинациях

            Stopwatch sw = new Stopwatch();
            sw.Start();

            HashSet<string> bestResult = new HashSet<string>();
            double best = 0;
            foreach (IList<int> v in variations)
            {
                if (v[0] + v[1] + v[2] + v[3] + v[4] == 10)         //проверка, если количество мешков 10
                {
                    double result = matrix[v[0], 0] + matrix[v[1], 1] + matrix[v[2], 2] + matrix[v[3], 3] + matrix[v[4], 4];
                    if (result > best)                              //если найдено значение с бОльшей прибылью
                    {
                        best = result;
                        bestResult.Clear();                        //отчистка листа при нахождении большего результата
                        bestResult.Add(string.Format("[{0} {1} {2} {3} {4}]", v[0], v[1], v[2], v[3], v[4])); //добавление объекта в хешсет
                    }
                    else if (result == best)
                        bestResult.Add(string.Format("[{0} {1} {2} {3} {4}]", v[0], v[1], v[2], v[3], v[4])); //если количество прибыли одинаково
                }
            }

            string answer = string.Empty;
            foreach (var route in bestResult)
                answer += route + "\n";

            sw.Stop();
            WriteLine("Наибольшая прибыль при: \n{0}Cо значением {1}\n{2} ms", answer, best, sw.ElapsedMilliseconds);
            ReadKey();
        }
    }
}